/**
 * @module    mod_treasurehunt/play
 * @package   mod_treasurehunt
 * @copyright 2016 onwards Adrian Rodriguez Fernandez <huorwhisp@gmail.com>, Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @author Adrian Rodriguez <huorwhisp@gmail.com>
 * @author Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define(["jquery","core/url","mod_treasurehunt/ol","core/ajax","mod_treasurehunt/osm-geocoder","mod_treasurehunt/viewgpx","core/str","mod_treasurehunt/webqr","mod_treasurehunt/jquery.truncate","mod_treasurehunt/dropdown"],(function(e,t,a,o,s,l,n,i){return{playtreasurehunt:function(e,t,a,o,s,l,i,c,u,d){let m=["stageovercome","failedlocation","stage","stagename","stageclue","question","noanswerselected","timeexceeded","searching","continue","noattempts","aerialview","roadview","noresults","startfromhere","nomarks","updates","activitytoendwarning","huntcompleted","discoveredlocation","answerwarning","error","pegmanlabel"],g=m.map((e=>({key:e,component:"treasurehunt"})));n.get_strings(g).done((n=>{let g=[];for(let e=0;e<m.length;e++)g[m[e]]=n[e];if(void 0!==d&&d&&d.custombackgroundurl){let n=new Image;n.addEventListener("load",(function(){d.imgwidth=this.naturalWidth,d.imgheight=this.naturalHeight,r(g,e,t,a,o,s,l,i,c,u,d)})),n.src=d.custombackgroundurl}else r(g,e,t,a,o,s,l,i,c,u,d)}))}};function r(n,r,c,u,d,m,g,p,y,f,h){xe(!0);let w="EPSG:3857",v=null,b=!0,x=15,k="ontouchstart"in window||navigator.msMaxTouchPoints;if(h){if(h.custombackgroundurl){let e=a.proj.transformExtent(h.bbox,"EPSG:4326",w);if(0==h.geographic){let t=e[3]-e[1],a=(e[2]+e[0])/2,o=(e[3]+e[1])/2,s=Math.round(t/h.imgheight),l=Math.round(h.imgwidth*s),n=Math.round(h.imgheight*s);e=[a-l/2,o-n/2,a+l/2,o+n/2],x=5}v=new a.layer.Image({title:h.layername,name:h.layername,type:h.layertype,source:new a.source.ImageStatic({url:h.custombackgroundurl,imageExtent:e}),opacity:1})}else if(h.wmsurl){let e={type:h.layertype,title:h.layername,name:h.layername};if("wms"===h.layerservicetype?e.source=new a.source.TileWMS({url:h.wmsurl,params:h.wmsparams}):"tiled"===h.layerservicetype?e.source=new a.source.XYZ({url:h.wmsurl}):"arcgis"===h.layerservicetype&&(e.source=new a.source.TileArcGISRest({url:h.wmsurl})),h.bbox[0]&&h.bbox[1]&&h.bbox[2]&&h.bbox[3]){let t=a.proj.transformExtent(h.bbox,"EPSG:4326",w);e.extent=t}v=new a.layer.Tile(e),v.set("name",h.layername)}b=h.geographic}!1===b&&(u=!0,e("#autolocate").hide());let P,S,E=t.imageUrl("success_mark","treasurehunt"),G=t.imageUrl("failure_mark","treasurehunt"),T=t.imageUrl("bootstrap/my_location_3","treasurehunt"),C={},I=[],_=[],q=!1,F=!1,j=!1,V=!1,A=!1,z=!0,M=!1,D=0,L=new a.style.Text({textAlign:"center",scale:1.3,fill:new a.style.Fill({color:"#ffffff"}),stroke:new a.style.Stroke({color:"#000000",width:3.5})}),R=new a.style.Text({textAlign:"center",scale:1.4,fill:new a.style.Fill({color:"#fff"}),stroke:new a.style.Stroke({color:"#0097a7",width:3.5})}),$=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:E}),text:L,zIndex:"Infinity"}),O=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:G}),text:L,zIndex:"Infinity"}),N=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:E}),text:R,zIndex:"Infinity"}),Q=new a.style.Style({image:new a.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:G}),text:R,zIndex:"Infinity"}),W=new a.style.Style({image:new a.style.Circle({radius:6,fill:new a.style.Fill({color:[0,0,0,1]}),stroke:new a.style.Stroke({color:[255,255,255,1],width:2})})}),Z=new a.style.Style({fill:new a.style.Fill({color:[255,255,255,.3]}),stroke:new a.style.Stroke({color:[0,0,0,.5],width:1}),zIndex:-1}),B=new a.style.Style({image:new a.style.Icon({anchor:[.5,.9],opacity:1,scale:1,src:T})}),H=[],U=new a.format.GeoJSON,X=new a.source.Vector({projection:"EPSG:3857"}),Y=new a.layer.Vector({source:X,style:function(e){let t=e.get("stageposition");if(0===t){let e=new a.style.Fill({color:"rgba(0,0,0,0.1)"}),t=new a.style.Stroke({color:"#0097a7",width:2});return[new a.style.Style({image:new a.style.Circle({fill:e,stroke:t,radius:5}),fill:e,stroke:t,text:new a.style.Text({text:n.startfromhere,textAlign:"center",fill:new a.style.Fill({color:"rgb(255,255,255)"}),stroke:new a.style.Stroke({color:"#0097a7",width:2}),overflow:!0,scale:2})})]}if(!e.get("geometrysolved"))return O.getText().setText(""+t),[O];return $.getText().setText(""+t),[$]}}),K=[],J=[];if(!h||!1===h.onlybase){let e=new a.layer.Tile({visible:!1,source:new a.source.BingMaps({key:"AmC3DXdnK5sXC_Yp_pOLqssFSaplBbvN68jnwKTEM3CSn2t6G5PGTbYN3wzxE5BR",imagerySet:"AerialWithLabels",maxZoom:19})}),t=new a.layer.Tile({source:new a.source.OSM});e.set("name",n.aerialview),t.set("name",n.roadview),K=[e,t]}v&&("overlay"!=h.layertype?K.push(v):J.push(v));let ee=new a.layer.Group({layers:K});var te=l.createCoordsOverlay("#mapplay","css/playerbootstrap/ol-popup.css",n.pegmanlabel);let ae=null;ee.getLayers().forEach((e=>{e.setVisible(!1),ae=e})),ae.setVisible(!0);let oe=new a.View({center:[0,0],zoom:2,minZoom:2}),se=new a.interaction.Select({layers:[Y],style:function(e){let t=e.get("stageposition");if(!e.get("geometrysolved"))return Q.getText().setText(""+t),[Q];return N.getText().setText(""+t),[N]},filter:e=>0!==e.get("stageposition")}),le=new a.Feature;le.setProperties({name:"user_accuracy"}),le.setStyle(Z);let ne=new a.Feature;ne.setProperties({name:"user_position"}),ne.setStyle(W);let ie=new a.layer.Vector({source:new a.source.Vector({features:[le,ne]})}),re=new a.Feature;re.setGeometry(null),re.setStyle(B);let ce=new a.layer.Vector({source:new a.source.Vector({features:[re]})});H.push(ee),H=H.concat(J),H=H.concat([Y,ie,ce]);let ue=new a.control.Zoom({target:"navigation",className:"custom-zoom"}),de=new a.Map({layers:H,overlays:[te],controls:[ue],target:"mapplay",view:oe,loadTilesWhileAnimating:!0,loadTilesWhileInteracting:!0});if(de.addInteraction(se),ge(!1,!0),P=setInterval((()=>{ge(!1,!1)}),p),function(t){t.getLayers().forEach((a=>{let o=e("<button>",{type:"button",class:"list-group-item list-group-item-action close-modal"}).click((()=>{t.getLayers().forEach((e=>{e===a?e.setVisible(!0):e.setVisible(!1)}))})),s=e("<div>",{text:a.get("name"),class:"layer-item "+(a.getVisible()?"":"unchecked")}).append(e("<i class='fa fa-check-circle'>"));o.append(s),a.on("change:visible",(()=>{e(s).toggleClass("unchecked")})),e("#layerslist").prepend(o)}))}(ee),J.forEach((e=>{pe(e)})),y&&f){let e=l.addgpxlayer(de,r,c,n,f,"trackgroup");e.set("name",e.get("title"));let t=e.getLayers().item(0),a=t.get("title");t.set("name",a),t.setVisible(!1),pe(t)}function me(e,t,a){let o=e.getView();a?o.fit(a,{duration:700}):o.animate({zoom:x,center:t,duration:700})}function ge(t,s,l,i){let r,p,f,h;f=u?re.getGeometry():ne.getGeometry(),f&&(p=U.writeGeometryObject(f,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),l&&(xe(!0),h=l),t&&(r=p,xe(!0)),o.call([{methodname:"mod_treasurehunt_user_progress",args:{userprogress:{treasurehuntid:c,attempttimestamp:m,roadtimestamp:g,playwithoutmoving:u,groupmode:d,initialize:s,location:r,currentposition:y&&!u?p:void 0,selectedanswerid:h,qoaremoved:M,qrtext:i}}}])[0].done((o=>{if(M=o.qoaremoved,A=o.roadfinished,z=o.available,xe(!1),(t||l)&&(null!==o.status&&z&&he(o.status.msg),re.setGeometry(null)),u!=o.playwithoutmoving&&((u=o.playwithoutmoving)||re.setGeometry(null)),d!=o.groupmode&&(d=o.groupmode),m===o.attempttimestamp&&g===o.roadtimestamp&&!s&&z||(m=o.attempttimestamp,g=o.roadtimestamp,o.attempthistory.length>0&&(_=o.attempthistory,q=!0),(o.attempts||o.firststagegeom)&&(X.clear(),o.firststagegeom&&X.addFeatures(U.readFeatures(o.firststagegeom,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),o.attempts.features.length>0&&X.addFeatures(U.readFeatures(o.attempts,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"}))),o.lastsuccessfulstage&&(C=o.lastsuccessfulstage,F=!0,we("#cluepage"),e("#validateqr").hide(),""!==C.question?(j=!0,e("#validatelocation").hide()):C.activitysolved?(e("#validatelocation").show(),o.qrexpected&&e("#validateqr").show()):e("#validatelocation").hide()),(o.firststagegeom||s)&&(V=!0),F&&(C.clue=C.clue.replace(/color/gm,"color-disabled"),e("#lastsuccessfulstageclue").html(C.clue),e("#lastsuccessfulstagename").text(C.name),e("#lastsuccesfulstagepos").text(C.position+" / "+C.totalnumber),""!==C.question?e("#questionbutton").show():e("#questionbutton").hide(),F=!1),function(){if(V){let e=X.getFeatures();1===e.length&&e[0].getGeometry()instanceof a.geom.Point?me(de,e[0].getGeometry().getCoordinates()):me(de,null,X.getExtent()),V=!1}}(),function(){if(j){C.question=C.question.replace(/color/gm,"color-disabled"),e("#questionform").html("<legend>"+C.question+"</legend>");let t=1;e.each(C.answers,((a,o)=>{let s="answer"+t;o.answertext=o.answertext.replace(/color/gm,"color-disabled"),e("#questionform").append(`<div class="form-check">\n                <input class="form-check-input" type="radio" name="answers" id="${s}" value="${o.id}">\n                <label class="form-check-label" for="${s}">\n                  ${o.answertext}\n                </label>\n            </div>`),t++})),j=!1}}(),function(){if(q){let t=e("#historylist");t.html(""),q=!1,0===_.length?e("<li>"+n.noattempts+"</li>").appendTo(t):_.forEach((a=>{e("<li><span class='ui-btn-icon-left "+(a.penalty?"ui-icon-delete failedattempt":"ui-icon-check successfulattempt")+"' style='position:relative'></span>"+a.string+"</li>").appendTo(t)}))}}()),o.infomsg.length>0){let t="";I.forEach((e=>{t+="<p>"+e+"</p>"})),o.infomsg.forEach((e=>{I.push(e),t+="<p>"+e+"</p>"})),e("#notificationsPopup .update-list").html(t),we("#notificationsPopup")}A||e("#roadended").hide(),!A&&z||(e("#validatelocation").hide(),e("#question_button").hide(),e("#roadended").show(),re.setGeometry(null),u=!1,clearInterval(P),e("#mapplay").css("opacity","0.8"))})).fail((t=>{e("#errorPopup .play-modal-content").text(t.message),we("#errorPopup"),clearInterval(P)}))}function pe(t){let a=e("<button>",{type:"button",class:"list-group-item list-group-item-action close-modal"}).click((()=>{t.setVisible(!t.getVisible())})),o=e.parseHTML(t.get("name")),s=e("<div>",{class:"layer-item "+(t.getVisible()?"":"unchecked")}).append(o,e("<i class='fa fa-check-circle'>"));a.append(s),t.on("change:visible",(()=>{e(s).toggleClass("unchecked")})),e("#layerslist").prepend(a)}let ye=new a.Geolocation({projection:oe.getProjection(),trackingOptions:{enableHighAccuracy:!0,maximumAge:0,timeout:1e4}});ye.on("change:position",(()=>{let e=ye.getPosition();ne.setGeometry(e?new a.geom.Point(e):null),ye.get("center")&&(me(de,e),ye.setProperties({center:!1})),ye.get("validate_location")&&(ge(!0,!1),ye.setProperties({validate_location:!1}))})),ye.on("change:accuracyGeometry",(()=>{le.setGeometry(ye.getAccuracyGeometry())}));let fe=!1;function he(t){const a=e(`<div class='play-toast slide-in-bottom'>${t}</div>`);a.appendTo(e(".play-toast-container")),setTimeout((()=>a.addClass("slide-out-top")),3e3),setTimeout((()=>a.remove()),3500)}function we(t){ve();const a=e(t);a.trigger("modal:open"),a.addClass("active"),e(`${t} .modal-mask`).addClass("active dismissible")}function ve(){const t=e(".play-modal.active");t.trigger("modal:close"),t.removeClass("active"),e(".modal-mask").removeClass("active dismissible")}function be(e,t){return`<div class="card">\n          <div class="card-body">\n            <h5 class="card-title">${e}</h5>\n            <h6 class="card-subtitle text-muted">${t}</h6>\n          </div>\n      </div>`}function xe(t){t?e(".global-loader").addClass("active"):e(".global-loader").removeClass("active")}function ke(e){ve(),he("QR code readed: "+e),ge(!1,!1,null,e)}function Pe(t){"string"==typeof t?e("#errorQR").text(t):(null!==t.cameras[t.camera].name&&e("#errorQR").text(t.cameras[t.camera].name),t.cameras.length>1?e("#nextcamera").show():e("#nextcamera").hide())}ye.on("error",(e=>{ye.setProperties({user_denied:!0}),he(e.message),e.code==e.PERMISSION_DENIED&&y&&!u&&0==fe&&setTimeout((()=>{we("#geolocationPopup"),fe=!0}),500)})),ye.setTracking(y),k||de.on("pointermove",(e=>{if(e.dragging)return;const t=de.getEventPixel(e.originalEvent);let o=!1;de.forEachFeatureAtPixel(t,(e=>{e.getGeometry()instanceof a.geom.MultiPolygon||(o=!0)}),{layerFilter:e=>e===Y}),de.getTargetElement().style.cursor=o?"pointer":"crosshair"})),se.on("select",(t=>{if(1===t.selected.length){let a=t.selected[0].get("name"),o=t.selected[0].get("clue"),s=t.selected[0].get("info"),l="",i="";s&&(l="<p>"+s+"</p>"),t.selected[0].get("geometrysolved")?a&&o?(i=n.stageovercome,l+=be(n.stagename,a),l+=be(n.stageclue,o)):i=n.discoveredlocation:i=n.failedlocation,e("#infoStagePopup .title").text(i),e("#infoStagePopup .play-modal-content").html(l),we("#infoStagePopup")}})),de.on("click",(e=>{let t=!1;if(de.forEachFeatureAtPixel(de.getEventPixel(e.originalEvent),(e=>{if(0===e.get("stageposition")||"user_position"===e.get("name")||"user_accuracy"===e.get("name"))return!1;t=!0})),u&&!t){let t=de.getEventCoordinate(e.originalEvent);re.setGeometry(t?new a.geom.Point(t):null),(null===h||h.geographic)&&te.setPosition(e.coordinate)}})),e("#searchInput").on("input",(t=>{S&&S.abort(),D&&clearTimeout(D);const o=e("#searchsResults"),l=t.target.value;o.html(""),l&&l.length>2&&(e(".search-loading").addClass("active"),D=setTimeout((()=>{S=s.search(l).done((t=>{e(".search-loading").removeClass("active"),0===t.length?o.html("<li class='list-group-item'>"+n.noresults+"</li>"):e.each(t,((t,s)=>{let l=e("<button>",{type:"button",class:"list-group-item list-group-item-action"}).appendTo(o).click((()=>{let t=[];t[0]=parseFloat(s.boundingbox[2]),t[1]=parseFloat(s.boundingbox[0]),t[2]=parseFloat(s.boundingbox[3]),t[3]=parseFloat(s.boundingbox[1]),t=a.proj.transformExtent(t,"EPSG:4326","EPSG:3857"),me(de,null,t),e("#searchpanel").removeClass("active"),e(".sidebar-mask").removeClass("active dismissible")})),n=e("<div>",{text:s.display_name,class:"search-option"}).append(e("<i class='fa fa-chevron-circle-right'>"));l.append(n)}))})).fail((()=>{})).always((()=>{S=null}))}),400))})),e("#infoStagePopup").on("modal:close",(()=>{se.getFeatures().clear()})),e("#acceptupdates").on("click",(()=>{I=[]})),e("#qrpage").on("modal:open",(()=>{i.loadQR(ke,Pe)})),e("#qrpage").on("modal:close",(()=>{i.unloadQR(Pe)})),e("#nextcamera").on("click",(()=>{let e=i.getDetectedCameras();if(null!==e){he("Give access to:"+e[i.getnextwebCam()].name)}i.setnextwebcam(Pe)})),e(window).on("resize",(()=>{de.updateSize()})),b&&e("#autolocate").on("click",(()=>{ye.get("user_denied")?we("#geolocationPopup"):function(){const e=ye.getPosition();me(de,e)}()})),e("#infopanel").on("sidebar:close",(()=>{se.getFeatures().clear()})),e("#sendLocation").on("click",(()=>{u&&!re.getGeometry()?he(n.nomarks):ge(!0,!1)})),e("#sendAnswer").on("click",(t=>{let a=e("#questionform input[type='radio']:checked");z?0===a.length?(t.preventDefault(),he(n.noanswerselected)):ge(!1,!1,a.val()):(t.preventDefault(),he(n.timeexceeded))})),e("#validatelocation").on("click",(e=>A?(e.preventDefault(),void he(n.huntcompleted)):z?""!==C.question?(e.preventDefault(),he(n.answerwarning),void we("#cluepage")):C.activitysolved?void 0:(e.preventDefault(),he(n.activitytoendwarning),void we("#cluepage")):(e.preventDefault(),void he(n.timeexceeded)))),e(document).on("click",'*[data-rel="sidebar"]',(t=>{const a=t.currentTarget,o=e(a.dataset.ref);o.trigger("sidebar:open"),o.addClass("active"),null!==a.dataset.dismissible&&e(".sidebar-mask").addClass("active dismissible")})),e(document).on("click",".close-sidebar, .sidebar-mask",(()=>{const t=e(".sidebar.active");t.trigger("sidebar:close"),t.removeClass("active"),e(".sidebar-mask").removeClass("active dismissible")})),e(document).on("click",'*[data-rel="modal"]',(t=>{ve();const a=t.currentTarget,o=e(a.dataset.ref);o.trigger("modal:open"),o.addClass("active"),e(a.dataset.ref+" .modal-mask").addClass("active"),null!==a.dataset.dismissible&&e(a.dataset.ref+" .modal-mask").addClass("dismissible")})),e(document).on("click",".close-modal, .modal-mask.dismissible",(()=>{ve()}))}}));