/**
 * @module    mod_treasurehunt/play
 * @package   mod_treasurehunt
 * @copyright 2016 onwards Adrian Rodriguez Fernandez <huorwhisp@gmail.com>, Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @author Adrian Rodriguez <huorwhisp@gmail.com>
 * @author Juan Pablo de Castro <jpdecastro@tel.uva.es>
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define(["jquery","core/url","mod_treasurehunt/ol","core/ajax","mod_treasurehunt/osm-geocoder","mod_treasurehunt/viewgpx","mod_treasurehunt/webqr","mod_treasurehunt/jquery.truncate","mod_treasurehunt/jquery.mobile-config","mod_treasurehunt/jquerymobile"],(function(e,t,o,n,i,a,s){return console.log("loading play.js with jquery "+e().jquery),{playtreasurehunt:function(e,t,o,n,i,a,s,r,c,u){console.log("loading i18n strings");["stageovercome","failedlocation","stage","stagename","stageclue","question","noanswerselected","timeexceeded","searching","continue","noattempts","aerialview","roadview","noresults","startfromhere","nomarks","updates","activitytoendwarning","huntcompleted","discoveredlocation","answerwarning","error","pegmanlabel"].map((function(e){return{key:e,component:"treasurehunt"}}));if(i18n=i18nplay,null!=u&&null!==u.custombackgroundurl){console.log("Detecting custom background image dimensions.");var d=new Image;d.addEventListener("load",(function(){u.imgwidth=this.naturalWidth,u.imgheight=this.naturalHeight,console.log("image is "+this.naturalWidth+"x"+this.naturalHeight+"pixels"),l(i18n,e,t,o,n,i,a,s,r,c,u)})),d.src=u.custombackgroundurl}else l(i18n,e,t,o,n,i,a,s,r,c,u)}};function l(l,r,c,u,d,p,g,m,h,f,y){console.log("init player Openlayers"),e.mobile.loading("show");var w="EPSG:3857",v=null,b=!0,x=15;if(null!=y){if(null!=y.custombackgroundurl){console.log("config custom background image");var k=o.proj.transformExtent(y.bbox,"EPSG:4326",w);if(!y.geographic){k[2],k[0];var T=k[3]-k[1],S=(k[2]+k[0])/2,P=(k[3]+k[1])/2,q=Math.round(T/y.imgheight),E=Math.round(y.imgwidth*q),G=Math.round(y.imgheight*q);k=[S-E/2,P-G/2,S+E/2,P+G/2],x=5}v=new o.layer.Image({title:y.layername,name:y.layername,type:y.layertype,source:new o.source.ImageStatic({url:y.custombackgroundurl,imageExtent:k}),opacity:1})}else if(null!==y.wmsurl){console.log("config custom wms server: "+y.wmsurl);let e={type:y.layertype,title:y.layername,name:y.layername};if("wms"===y.layerservicetype?e.source=new o.source.TileWMS({url:y.wmsurl,params:y.wmsparams}):"tiled"===y.layerservicetype?e.source=new o.source.XYZ({url:y.wmsurl}):"arcgis"===y.layerservicetype&&(e.source=new o.source.TileArcGISRest({url:y.wmsurl})),e.type=y.layertype,e.title=y.layername,e.name=y.layername,null!==y.bbox[0]&&null!==y.bbox[1]&&null!==y.bbox[2]&&null!==y.bbox[3]){var I=o.proj.transformExtent(y.bbox,"EPSG:4326",w);e.extent=I}v=new o.layer.Tile(e)}b=y.geographic}!1===b&&(console.log("geographic tools disabled"),u=!0,e("#autolocate").hide());var C,_=t.imageUrl("success_mark","treasurehunt"),j=t.imageUrl("failure_mark","treasurehunt"),A=t.imageUrl("my_location","treasurehunt"),F={},V=0,z=0,R=[],D=[],L=!1,M=!1,Q=!1,O=!1,W=!1,H=!0,N=!1;let Z,B=0;var U=new o.style.Text({textAlign:"center",scale:1.3,fill:new o.style.Fill({color:"#fff"}),stroke:new o.style.Stroke({color:"#000",width:3.5})}),X=new o.style.Text({textAlign:"center",scale:1.4,fill:new o.style.Fill({color:"#fff"}),stroke:new o.style.Stroke({color:"#3399CC",width:3.5})}),Y=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:_}),text:U,zIndex:"Infinity"}),K=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.5,src:j}),text:U,zIndex:"Infinity"}),J=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:_}),text:X,zIndex:"Infinity"}),$=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.75,src:j}),text:X,zIndex:"Infinity"}),ee=new o.style.Style({image:new o.style.Circle({radius:6,fill:new o.style.Fill({color:[0,0,0,1]}),stroke:new o.style.Stroke({color:[255,255,255,1],width:2})})}),te=new o.style.Style({fill:new o.style.Fill({color:[255,255,255,.3]}),stroke:new o.style.Stroke({color:[0,0,0,.5],width:1}),zIndex:-1}),oe=new o.style.Style({image:new o.style.Icon({anchor:[.5,1],opacity:1,scale:.35,src:A})}),ne=[],ie=new o.format.GeoJSON,ae=new o.source.Vector({projection:"EPSG:3857"}),se=new o.layer.Vector({source:ae,style:function(e,t){var n=e.get("stageposition");if(0===n){var i=new o.style.Fill({color:"rgba(255,255,255,0.4)"}),a=new o.style.Stroke({color:"#3399CC",width:1.25});return[new o.style.Style({image:new o.style.Circle({fill:i,stroke:a,radius:5}),fill:i,stroke:a,text:new o.style.Text({text:l.startfromhere,textAlign:"center",fill:new o.style.Fill({color:"rgb(255,255,255)"}),stroke:new o.style.Stroke({color:"#3399CC",width:2}),overflow:!0,scale:2})})]}if(!e.get("geometrysolved"))return K.getText().setText(""+n),[K];return Y.getText().setText(""+n),[Y]}}),le=new o.layer.Tile({visible:!1,source:new o.source.BingMaps({key:"AmC3DXdnK5sXC_Yp_pOLqssFSaplBbvN68jnwKTEM3CSn2t6G5PGTbYN3wzxE5BR",imagerySet:"AerialWithLabels",maxZoom:19})});le.set("name",l.aerialview);var re=new o.layer.Tile({source:new o.source.OSM});re.set("name",l.roadview);var ce=[],ue=[];null!==y&&!1!==y.onlybase||(ce=[le,re]),null!==v&&("overlay"!=y.layertype?ce.push(v):ue.push(v));var de=new o.layer.Group({layers:ce}),pe=a.createCoordsOverlay("#mapplay","css/playerfancy/ol-popup.css",l.pegmanlabel),ge=null;de.getLayers().forEach((function(e){e.setVisible(!1),ge=e})),ge.setVisible(!0);var me=new o.View({center:[0,0],zoom:2,minZoom:2}),he=new o.interaction.Select({layers:[se],style:function(e,t){var o=e.get("stageposition");if(!e.get("geometrysolved"))return $.getText().setText(""+o),[$];return J.getText().setText(""+o),[J]},filter:function(e,t){return 0!==e.get("stageposition")}}),fe=new o.Feature;fe.setProperties({name:"user_accuracy"}),fe.setStyle(te);var ye=new o.Feature;ye.setProperties({name:"user_position"}),ye.setStyle(ee);var we=new o.layer.Vector({source:new o.source.Vector({features:[fe,ye]})}),ve=new o.Feature;ve.setGeometry(null),ve.setStyle(oe);var be=new o.layer.Vector({source:new o.source.Vector({features:[ve]})});ne.push(de),ne=(ne=ne.concat(ue)).concat([se,we,be]);var xe=new o.control.Zoom({target:"navigation",className:"custom-zoom"}),ke=new o.control.Attribution({collapsible:!1}),Te=new o.Map({layers:ne,overlays:[pe],controls:[xe,ke],target:"mapplay",view:me,loadTilesWhileAnimating:!0,loadTilesWhileInteracting:!0});if(Te.addInteraction(he),Ge(!1,!0),C=setInterval((function(){Ge(!1,!1)}),m),function(t){t.getLayers().forEach((function(o){var n=e("<li>",{"data-icon":"check",class:o.getVisible()?"checked":"unchecked"}).append(e("<a />",{text:o.get("name"),href:"#mappage"}).click((function(){t.getLayers().forEach((function(e){e===o?e.setVisible(!0):e.setVisible(!1)}))})));o.on("change:visible",(function(){e(n).toggleClass("checked unchecked")})),n.insertAfter("#baseLayer")}))}(de),ue.forEach((function(e){je(e)})),h&&f){var Se=a.addgpxlayer(Te,r,c,l,f,"trackgroup");Se.set("name",Se.get("title"));var Pe=Se.getLayers().item(0),qe=Pe.get("title");Pe.set("name",qe),Pe.setVisible(!1),je(Pe)}function Ee(e,t,o){var n=e.getView();o?n.fit(o,{duration:700}):n.animate({zoom:x,center:t,duration:700})}function Ge(t,o,i,a){var s,r,m,f;(m=u?ve.getGeometry():ye.getGeometry())&&(r=ie.writeGeometryObject(m,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),i&&(e.mobile.loading("show"),f=i),t&&(s=r,e.mobile.loading("show")),n.call([{methodname:"mod_treasurehunt_user_progress",args:{userprogress:{treasurehuntid:c,attempttimestamp:p,roadtimestamp:g,playwithoutmoving:u,groupmode:d,initialize:o,location:s,currentposition:h&&!u?r:void 0,selectedanswerid:f,qoaremoved:N,qrtext:a}}}])[0].done((function(n){var a="";if(N=n.qoaremoved,W=n.roadfinished,H=n.available,e.mobile.loading("hide"),(t||i)&&null!==n.status&&H&&console.log(n.status.msg),u!=n.playwithoutmoving&&((u=n.playwithoutmoving)||ve.setGeometry(null)),d!=n.groupmode&&(d=n.groupmode),p!==n.attempttimestamp||g!==n.roadtimestamp||o||!H){p=n.attempttimestamp,g=n.roadtimestamp,n.attempthistory.length>0&&(D=n.attempthistory,L=!0),(n.attempts||n.firststagegeom)&&(ae.clear(),n.firststagegeom&&ae.addFeatures(ie.readFeatures(n.firststagegeom,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"})),n.attempts.features.length>0&&ae.addFeatures(ie.readFeatures(n.attempts,{dataProjection:"EPSG:4326",featureProjection:"EPSG:3857"}))),n.lastsuccessfulstage&&(F=n.lastsuccessfulstage,M=!0,e("#validateqr").hide(),""!==F.question?(Q=!0,e("#validatelocation").show().addClass("ui-state-disabled"),Oe("question")):F.activitysolved?(e("#validatelocation").show().removeClass("ui-state-disabled"),Oe("clue"),n.qrexpected&&e("#validateqr").show()):(e("#validatelocation").show().addClass("ui-state-disabled"),Oe("question"))),(n.firststagegeom||o)&&(O=!0);var s=e.mobile.pageContainer.pagecontainer("getActivePage").prop("id");"mappage"===s||("historypage"===s?_e():"questionpage"===s&&(""===F.question?e.mobile.pageContainer.pagecontainer("change","#mappage"):e.mobile.resetActivePageHeight())),function(){if(M){e("#lastsuccessfulstagename").text(l.stage+":"+F.name),e("#lastsuccesfulstagepos").text(F.position+" / "+F.totalnumber);var t,o=100;F.clue=F.clue.replace(/color/gm,"color-disabled"),e("#lastsuccessfulstageclue").html(F.clue),F.clue.replace(/<(?:.|\n)*?>/gm,"").length>2*o?(e("#lastsuccessfulstageclue").truncate(2*o),t=' <a href="#historypage" data-transition="none" class="ui-btn ui-shadow ui-corner-all ui-btn-icon-left ui-btn-inline ui-icon-bullets ui-btn-icon-notext"></a> ',e("#lastsuccessfulstageclue").append(t)):t=F.clue,e("[id=lastsuccessfulstagename2]").text(F.name),e("[id=lastsuccesfulstagepos2").text(F.position+" / "+F.totalnumber),e("[id=lastsuccessfulstageclue2]").html(F.clue),""!==F.question?(e("#lastsuccessfulstageclue").append("<a href='#questionpage' data-transition='none' class='ui-btn ui-shadow ui-corner-all ui-btn-icon-left ui-btn-inline ui-mini ui-icon-comment'>"+l.question+"</a>"),e("[id=lastsuccessfulstageclue2]").append("<a href='#questionpage' data-transition='none' class='ui-btn ui-shadow ui-corner-all ui-btn-icon-left ui-btn-inline ui-mini ui-icon-comment'>"+l.question+"</a>"),e("#sendAnswer").show()):(e("#questionform").html(""),e("#sendAnswer").hide()),M=!1}}(),Ie(),Ce()}n.infomsg.length>0&&(R.forEach((function(e){a+="<p>"+e+"</p>"})),n.infomsg.forEach((function(e){R.push(e),a+="<p>"+e+"</p>"})),Le("displayupdates",l.updates,a)),W||e("#roadended").hide(),!W&&H||(e("#validatelocation").show().addClass("ui-state-disabled"),e("#question_button").hide(),e("#roadended").show(),ve.setGeometry(null),u=!1,clearInterval(C),e("#mapplay").css("opacity","0.8"))})).fail((function(e){console.log(e),Le("displayerror",l.error,e.message),clearInterval(C)}))}function Ie(){if(O){var e=ae.getFeatures();1===e.length&&e[0].getGeometry()instanceof o.geom.Point?Ee(Te,e[0].getGeometry().getCoordinates()):Ee(Te,null,ae.getExtent()),O=!1}}function Ce(){if(Q){F.question=F.question.replace(/color/gm,"color-disabled");var t="<legend>"+F.question+"</legend>",o=1;e.each(F.answers,(function(e,n){var i="answer"+o;n.answertext=n.answertext.replace(/color/gm,"color-disabled"),t+='<div class="answer"><input type="radio" name="answers" id="'+i+'"value="'+n.id+'"><label style="color:white" for="'+i+'">'+n.answertext+"</label></div>",o++})),e("#questionform").html(t).scrollTop(),e("#questionform").enhanceWithin(),setTimeout((()=>e("#questionform input").removeClass("ui-helper-hidden-accessible")),1),Q=!1}}function _e(){if(L){var t=e("#historylist");t.html(""),L=!1,0===D.length?e("<li>"+l.noattempts+"</li>").appendTo(t):D.forEach((function(o){e("<li><span class='ui-btn-icon-left "+(o.penalty?"ui-icon-delete failedattempt":"ui-icon-check successfulattempt")+"' style='position:relative'></span>"+o.string+"</li>").appendTo(t)})),t.listview("refresh"),t.trigger("updatelayout")}}function je(t){var o=e.parseHTML(t.get("name")),n=e("<li>",{"data-icon":"check",class:t.getVisible()?"checked":"unchecked"}).append(e("<a />",{href:"#mappage"}).click((function(){t.setVisible(!t.getVisible())})).append(o));t.on("change:visible",(function(){e(n).toggleClass("checked unchecked")})),n.insertAfter("#baseLayer")}var Ae=new o.Geolocation({projection:me.getProjection(),trackingOptions:{enableHighAccuracy:!0,maximumAge:0,timeout:1e4}});Ae.on("change:position",(function(){var t=this.getPosition();ye.setGeometry(t?new o.geom.Point(t):null),this.get("center")&&(Ee(Te,t),this.setProperties({center:!1})),this.get("validate_location")&&(Ge(!0,!1),this.setProperties({validate_location:!1})),e.mobile.loading("hide")})),Ae.on("change:accuracyGeometry",(function(){fe.setGeometry(this.getAccuracyGeometry()),e.mobile.loading("hide")}));var Fe=!1;(Ae.on("error",(function(t){e.mobile.loading("hide"),Ae.setProperties({user_denied:!0}),Re(t.message),t.code==t.PERMISSION_DENIED&&h&&!u&&0==Fe&&setTimeout((function(){e("#popupgeoloc").popup("open",{positionTo:"window"}),Fe=!0}),500)})),Ae.setTracking(h),he.on("select",(function(t){if(1===t.selected.length)if(F.position===t.selected[0].get("stageposition")&&t.selected[0].get("geometrysolved")&&!W&&H)De(),e("#lastsuccessfulstage").collapsible("expand");else{var o,n=t.selected[0].get("name"),i=t.selected[0].get("clue"),a=t.selected[0].get("info"),s="";t.selected[0].get("geometrysolved")?n&&i?(o=l.stageovercome,s=Qe(l.stagename,n),s+=Qe(l.stageclue,i)):o=l.discoveredlocation:o=l.failedlocation,a&&(s+="<p>"+a+"</p>"),Le("infostage",o,s)}})),Te.on("click",(function(e){var t=!1;if(Te.forEachFeatureAtPixel(Te.getEventPixel(e.originalEvent),(function(e,o){if(0===e.get("stageposition")||"user_position"===e.get("name")||"user_accuracy"===e.get("name"))return!1;t=!0})),u&&!t){var n=Te.getEventCoordinate(e.originalEvent);ve.setGeometry(n?new o.geom.Point(n):null),(null===y||y.geographic)&&pe.setPosition(e.coordinate)}})),e("#autocomplete").on("filterablebeforefilter",(function(t,n){if(!b)return;Z&&Z.abort(),B&&clearTimeout(B);let a=e(this),s=e(n.input).val();a.html(""),s&&s.length>2&&(e.mobile.loading("show",{text:l.searching,textVisible:!0,theme:"b"}),B=setTimeout((()=>{Z=i.search(s).done((t=>{0===t.length?a.html("<li data-filtertext='"+s+"'>"+l.noresults+"</li>"):e.each(t,((t,n)=>{e("<li data-filtertext='"+s+"'>").hide().append(e("<a href='#'>").text(n.display_name)).appendTo(a).click((function(){var t=[];t[0]=parseFloat(n.boundingbox[2]),t[1]=parseFloat(n.boundingbox[0]),t[2]=parseFloat(n.boundingbox[3]),t[3]=parseFloat(n.boundingbox[1]),t=o.proj.transformExtent(t,"EPSG:4326","EPSG:3857"),Ee(Te,null,t),e("#searchpanel").panel("close")})).show()})),a.listview("refresh"),a.trigger("updatelayout")})).fail((()=>{})).always((()=>{Z=null,e.mobile.loading("hide")}))}),400))})),e("#infopanel").on("collapsibleexpand","[data-role='collapsible']",(function(t,o){var n=e("#infopanel .ui-panel-inner");n.animate({scrollTop:parseInt(e(this).offset().top-n.offset().top+n.scrollTop())},500)})),e(document).on("popupbeforeposition",(function(){var t=e(window).height()-200+"px";e('.ui-popup [data-role="content"]').css("max-height",t)})),e(document).on("popupafterclose",".ui-popup:not(#QRdialog):not(#popupdialog):not(#popupgeoloc)",(function(){e(this).remove(),he.getFeatures().clear()})),e(document).on("click","#acceptupdates",(function(){R=[]})),e(window).on("pagecontainershow resize",(function(t,o){e.mobile.resetActivePageHeight();var n=e.mobile.pageContainer.pagecontainer("getActivePage").prop("id");"mappage"===n?"resize"===t.type?setTimeout((function(){Te.updateSize()}),200):(Te.updateSize(),Ie()):"historypage"===n?"pagecontainershow"===t.type&&_e():"questionpage"===n&&"pagecontainershow"===t.type&&(null!=F.question&&""!==F.question||!1===F.activitysolved?Ce():e.mobile.pageContainer.pagecontainer("change","#mappage")),setTimeout((()=>{var e=document.querySelector("#questionpage").style;e.setProperty("padding-top",e.paddingTop,"important")}),200)})),b&&e("#autolocate").on("click",(function(){Ae.get("user_denied")?e("#popupgeoloc").popup("open",{positionTo:"window"}):(position=Ae.getPosition(),Ee(Te,position))})),e("#infopanel").panel({beforeclose:function(){he.getFeatures().clear()}}),e("#sendLocation").on("click",(function(){u&&null===ve.getGeometry()?Re(l.nomarks):Ge(!0,!1)})),e("#sendAnswer").on("click",(function(t){var o=e("#questionform input[type='radio']:checked");H?0===o.length?(t.preventDefault(),Re(l.noanswerselected)):Ge(!1,!1,o.val()):(t.preventDefault(),Re(l.timeexceeded))})),e("#validatelocation").on("click",(function(e){return W?(e.preventDefault(),void Re(l.huntcompleted)):H?""!==F.question?(e.preventDefault(),Re(l.answerwarning),void De()):F.activitysolved?void 0:(e.preventDefault(),Re(l.activitytoendwarning),void De()):(e.preventDefault(),void Re(l.timeexceeded))})),!1===e.mobile.autoInitializePage)&&(e("#container").show(),e("#loader").remove(),e.mobile.initializePage(),document.querySelector("meta[name=viewport]").setAttribute("content","width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0"),e("#QRdialog").popup({beforeposition:function(t,o){e(this).width(.9*window.innerWidth),e(this).height(.9*window.innerHeight)},afteropen:function(t,o){var n=e(this).find("div[data-role='content']").first(),i=e(this).find("div[data-role='header']").first(),a=parseInt(n.css("padding-top"))+parseInt(n.css("padding-bottom"));n.css("max-height","1000px"),e("#previewVideoDiv").width(e(this).width()-a).height(e(this).height()-e("#previewQRbuttons").height()-i.height()-2*a),e("#previewQRvideo").show(),s.loadQR(Ve,ze)},afterclose:function(e,t){s.unloadQR(ze)}.bind(this)}));function Ve(t){e("#QRdialog").popup("close"),console.log(t),Re("QR code readed: "+t),Ge(!1,!1,null,t)}function ze(t){"string"==typeof t?e("#errorQR").text(t):(null!==t.cameras[t.camera].name&&e("#errorQR").text(t.cameras[t.camera].name),t.cameras.length>1?e("#nextcamera").show():e("#nextcamera").hide())}function Re(t){e(".toast").length>0?setTimeout((function(){Re(t)}),2500):e("<div class='ui-loader ui-overlay-shadow  ui-corner-all toast'><p>"+t+"</p></div>").css({left:(e(window).width()-284)/2,top:e(window).height()/2}).appendTo(e.mobile.pageContainer).delay(2e3).fadeOut(400,(function(){e(this).remove()}))}function De(){e("#bigbtn").click()}function Le(t,o,n){var i=e('<div data-role="header"><h2>'+o+"</h2></div>"),a=e('<div data-role="content" class="ui-content ui-overlay-b">'+n+"</div>"),s=e('<div data-role="popup" id="'+t+'"data-theme="b" data-transition="slidedown"></div>');if("infostage"===t&&e('<a href="#" data-rel="back" class="ui-btn ui-corner-allui-btn-b ui-icon-delete ui-btn-icon-notext ui-btn-right"></a>').appendTo(i),"displayupdates"===t){e('<p class="center-wrapper"><a id="acceptupdates" href="#" data-rel="back"class="ui-btn center-button ui-mini ui-btn-inline">'+l.continue+"</a></p>").appendTo(a);var c={"data-dismissible":!1,"data-overlay-theme":"b"};e(s).attr(c)}if("displayerror"===t){e('<p class="center-wrapper"><a href="view.php?id='+r+'" class="ui-btn  center-button ui-mini ui-icon-forward ui-btn-inline ui-btn-icon-left"data-ajax="false">'+l.continue+"</a></p>").appendTo(a);c={"data-dismissible":!1,"data-overlay-theme":"b"};e(s).attr(c)}if(e(i).appendTo(e(s).appendTo(e.mobile.activePage).popup()).toolbar().after(a),(z=e(a).find("img")).length>0){e.mobile.loading("show"),z.one("load",(function(){V++,z.length===V&&(Me(s),V=0,clearTimeout(u),e.mobile.loading("hide"))}));var u=setTimeout((function(){Me(s),e.mobile.loading("hide")}),2e3)}else Me(s)}function Me(t){e(".ui-popup-active").length>0?(e(".ui-popup").popup("close"),setTimeout((function(){e(t).popup("open",{positionTo:"window"})}),1e3)):e(t).popup("open",{positionTo:"window"})}function Qe(e,t){return'<div class="ui-bar ui-bar-a">'+e+'</div><div class="ui-body ui-body-a">'+t+"</div>"}function Oe(t){var o=e("#bigbtn")[0];o.href="#"+t+"page",btnImg=e("img",o)[0];var n=btnImg.src.replace(/btn_(\w+)$/,"btn_"+t);btnImg.src=n}e("#nextcamera").on("click",(function(){var e=s.getDetectedCameras();null!==e&&Re("Give access to:"+e[s.getnextwebCam()].name);s.setnextwebcam(ze)}))}}));